Subject: Re: [PATCH net-next 2/6] net: dsa: hellcreek: Report META data usage

From: Kurt Kanzenbach <[email-masked]>
Date: Fri, 12 Mar 2021 17:11:07 +0100

On Fri Mar 12 2021, Vladimir Oltean wrote:
> On Thu, Mar 11, 2021 at 11:52:41PM +0100, Andrew Lunn wrote:
>> On Thu, Mar 11, 2021 at 06:53:40PM +0100, Kurt Kanzenbach wrote:
>> > Report the META data descriptor usage via devlink.
>> 
>> Jakubs question is also relevant here. Please could you give a bit
>> more background about what the meta data is?
>
> Not having seen any documentation for this device, my guess is that
> metadata descriptors are frame references, and the RAM page count is
> for packet memory buffers. Nonetheless, I would still like to hear it
> from Kurt.

Yes, exactly.

> There is still a lot unknown even if I am correct. For example, if
> the frame references or buffers can be partitioned, or if watermarks for
> things like congestion/flow control can be set, then maybe devlink-sb is
> a better choice (as that has an occupancy facility as well)?
> Fully understand that it is not as trivial as exposing a devlink
> resource, but on Ocelot/Felix I quite appreciate having the feature
> (drivers/net/ethernet/mscc/ocelot_devlink.c). And knowing that this is a
> TSN switch, I expect that sooner or later, the need to have control over
> resource partitioning per traffic class will arise anyway.
>

True. The switch can actually distinguish between critical and
background traffic. Multiple limits can be configured: Maximum memory,
reserved memory for critical traffic, background traffic rates and queue
depths. I'll take a look at devlink-sb for that.

Thanks,
Kurt